#include <sys/pci.h>
#include "pci_r.h"

#define WORKER_NAME "qnx/_CA_PCI_Worker"
#define WORKER_PROC "CA_PCI_Worker"
#define WORKER_EXIT                       0xffff

struct Find_Device {
   unsigned devid; 
   unsigned venid; 
   unsigned index;
   unsigned busnum;
   unsigned devfuncnum;
};

struct Read_Config_Byte {
   unsigned busnum; 
   unsigned devfuncnum;
   unsigned offset; 
   unsigned cnt; 
   char bufptr[256];
};

struct Read_Config_Word {
   unsigned busnum; 
   unsigned devfuncnum;
   unsigned offset; 
   unsigned cnt; 
   char bufptr[256];
};

struct Read_Config_DWord {
   unsigned busnum; 
   unsigned devfuncnum;
   unsigned offset; 
   unsigned cnt; 
   char bufptr[256];
};

struct Write_Config_Byte {
   unsigned busnum; 
   unsigned devfuncnum;
   unsigned offset; 
   unsigned cnt; 
   char bufptr[256];
};

struct Write_Config_Word {
   unsigned busnum; 
   unsigned devfuncnum;
   unsigned offset; 
   unsigned cnt; 
   char bufptr[256];
};

struct Write_Config_DWord {
   unsigned busnum; 
   unsigned devfuncnum;
   unsigned offset; 
   unsigned cnt; 
   char bufptr[256];
};

struct Generate_Special_Cycle {
   unsigned Busnum;
   unsigned long SpecialCycleData;
};

struct Set_Hardware_Interrupt {
   unsigned Busnum; 
   unsigned devfuncnum;
   unsigned IntPin; 
   unsigned IRQNum;
};

struct Get_Routing_Options {
   struct _pci_route_buffer_r rbufptr;
   unsigned IRQForPCI;
};

struct Find_Class {
   unsigned long ClassCode; 
   unsigned index;
   unsigned busnum; 
   unsigned devfuncnum;
};

struct BIOS_Present {
   unsigned lastbus; 
   unsigned version;
   unsigned hardware;
};

struct pci_msg {
   int req;
   int status;
   union {
      struct Find_Device            fd;
      struct Read_Config_Byte       rcb;
      struct Read_Config_Word       rcw;
      struct Read_Config_DWord      rcd;
      struct Write_Config_Byte      wcb;
      struct Write_Config_Word      wcw;
      struct Write_Config_DWord     wcd;
      struct Generate_Special_Cycle gsc;
      struct Set_Hardware_Interrupt shi;
      struct Get_Routing_Options    gro;
      struct Find_Class             fc;
      struct BIOS_Present           bp;
   } req_info;
};
